/*
** $Id: icmp-compat.h,v 1.4 2000/01/06 08:25:24 odin Exp $
*/

#ifndef __ICMP_COMPAT_H
#define __ICMP_COMPAT_H

#define ICMP_ECHO_REPLY			0
#define ICMP_DEST_UNREACHABLE	3
#define ICMP_SOURCE_QUENCH		4
#define ICMP_REDIRECT			5
#define ICMP_ECHO				8
#define ICMP_ROUTER_ADVERT		9
#define ICMP_ROUTER_SOLICIT		10
#define ICMP_TIME_EXCEEDED		11
#define ICMP_PARAMETER_PROBLEM	12
#define ICMP_TIMESTAMP			13
#define ICMP_TIMESTAMP_REPLY	14
#define ICMP_INFO_REQUEST		15
#define ICMP_INFO_REPLY			16
#define ICMP_ADDRESS			17
#define ICMP_ADDRESS_REPLY		18
#define ICMP_UNDEFINED			19

#define UNREACHABLE_MAX		16
#define REDIRECT_MAX		3

/* stolen mostly from tcpdump :) */
struct icmp {
	u_char icmp_type;
	u_char icmp_code;
	u_short icmp_cksum;
	union {
		u_char ih_pptr;
		struct in_addr ih_gwaddr;
		struct ih_idseq {
			u_short icd_id;
			u_short icd_seq;
		} ih_idseq;

		u_long ih_reserved;
		struct ih_rdiscovery {
			u_char num_addr;
			u_char addr_entry_size;
			u_short lifetime;
		} ih_rdiscovery;
	} icmp_hun;
#define	icmp_pptr	icmp_hun.ih_pptr
#define	icmp_gwaddr	icmp_hun.ih_gwaddr
#define	icmp_id		icmp_hun.ih_idseq.icd_id
#define	icmp_seq	icmp_hun.ih_idseq.icd_seq
#define	icmp_void	icmp_hun.ih_void
#define	icmp_pmvoid	icmp_hun.ih_pmtu.ipm_void
#define	icmp_nextmtu	icmp_hun.ih_pmtu.ipm_nextmtu
	union {
		struct id_ts {
			u_int its_otime;
			u_int its_rtime;
			u_int its_ttime;
		} id_ts;
		struct id_ip {
			struct ip idi_ip;
		} id_ip;
		u_long id_mask;
		char id_data[1];
		struct id_rdiscovery {
			struct in_addr router_addr;
			struct in_addr pref_level;
		} id_rdiscovery;
	} icmp_dun;
#define icmp_num_addr			icmp_hun.ih_rdiscovery.num_addr
#define icmp_addr_entry_size	icmp_hun.ih_rdiscovery.addr_entry_size
#define icmp_lifetime			icmp_hun.ih_rdiscovery.lifetime
#define	icmp_otime				icmp_dun.id_ts.its_otime
#define	icmp_rtime				icmp_dun.id_ts.its_rtime
#define	icmp_ttime				icmp_dun.id_ts.its_ttime
#define	icmp_ip					icmp_dun.id_ip.idi_ip
#define	icmp_mask				icmp_dun.id_mask
#define	icmp_data				icmp_dun.id_data
};

#endif

/* vim:ts=4:sw=8:tw=0 */
